package 
{

import flash.display.Sprite;
import flash.display.MovieClip;
import flash.events.Event;
import flash.events.MouseEvent;
import flash.system.ApplicationDomain;
import flash.system.Capabilities;

import states.*;

/**
 * Sheep
 * 
 * @author neolao <neo@neolao.com>
 */
public class Sheep extends Sprite
{
	// ----------------------------- CONSTANTS ---------------------------------
	static public const WIDTH:uint = 40;
	static public const HEIGHT:uint = 40;
	
	// ----------------------------- VARIABLES ---------------------------------
	private var _currentState:MovieClip;
		
	/*============================= CONSTRUCTOR ==============================*/
	/*========================================================================*/
    /**
     * Constructor
     */
    public function Sheep()
    {
        super();
        
		this.addEventListener(Event.ADDED_TO_STAGE, this._init);
    }
    /*======================= END = CONSTRUCTOR = END ========================*/
	/*========================================================================*/

	/*================================ PUBLIC ================================*/
	/*========================================================================*/
	/**
	 * Start
	 */
	public function randomStart():void
	{
		var startStates:Array = new Array(
			Fall
		);
		var selectedState:Class = startStates[ Math.round(Math.random() * (startStates.length - 1)) ] as Class;
		this.state = selectedState.stateName;
	}
	/**
	 * The state
	 */
	public function get state():String
	{
		return this._currentState.stateName;
	}
	public function set state(pState:String):void
	{
		try {
			this.removeChild(this._currentState);
		} catch (error:*) {
		}
		
		var state:Class = ApplicationDomain.currentDomain.getDefinition("states."+pState) as Class;
		
		this._currentState = new state(this);
		this.addChild(this._currentState);
	}
	/*========================== END = PUBLIC = END ==========================*/
	/*========================================================================*/
	
	/*=============================== PRIVATE ================================*/
	/*========================================================================*/
	/**
	 * Initialization event
	 * 
	 * @param pEvent The event
	 */
	private function _init(pEvent:Event):void
	{
		this.stage.window.x = Math.round(Math.random() * (Capabilities.screenResolutionX - WIDTH) );
		this.stage.window.y = 0;
        
		this.randomStart();
        
		this.stage.addEventListener(MouseEvent.MOUSE_DOWN, this._onMouseDown);
		this.stage.addEventListener(MouseEvent.MOUSE_UP, this._onMouseUp);
	}
	/**
	 * Mouse down event
	 * 
	 * @param pEvent The event
	 */
	private function _onMouseDown(pEvent:MouseEvent):void
	{
		this.state = Drag.stateName;
		this.stage.window.startMove();
	}
	/**
	 * Mouse up event
	 * 
	 * @param pEvent The event
	 */
	private function _onMouseUp(pEvent:MouseEvent):void
	{
		this.state = Fall.stateName;
	}
	/*========================= END = PRIVATE = END ==========================*/
	/*========================================================================*/
}

}