package states
{

import flash.display.MovieClip;
import flash.system.Capabilities;
import flash.events.Event;
import flash.events.TimerEvent;
import flash.utils.Timer;

import Sheep;

/**
 * State stay
 * 
 * @author neolao <neo@neolao.com>
 */
public class AState extends MovieClip
{
	// ----------------------------- CONSTANTS ---------------------------------
	
	// ----------------------------- VARIABLES ---------------------------------
	static public var stateName:String = "null";
	public var sheep:Sheep;
	protected var _screen:Object;
	protected var _motionDelay:uint = 10;
	protected var _motion:Timer;
	protected var _animationDelay:uint = 100;
	protected var _animation:Timer;
	
	/*============================= CONSTRUCTOR ==============================*/
	/*========================================================================*/
    /**
     * Constructor
     * 
     * @param pSheepInstance The Sheep instance
     */
    public function AState(pSheepInstance:Sheep)
    {
        super();
        
        this.sheep = pSheepInstance;
        
        _screen = new Object();
        _screen.width = Capabilities.screenResolutionX;
        _screen.height = Capabilities.screenResolutionY;
        
        this.addEventListener(Event.ADDED_TO_STAGE, this._init);
        this.addEventListener(Event.REMOVED_FROM_STAGE, this._removed);
    }
    /*======================= END = CONSTRUCTOR = END ========================*/
	/*========================================================================*/

	/*================================ PUBLIC ================================*/
	/*========================================================================*/
	
	/*========================== END = PUBLIC = END ==========================*/
	/*========================================================================*/
	
	/*=============================== PRIVATE ================================*/
	/*========================================================================*/
	/**
	 * Initialization event
	 * 
	 * @param pEvent The event
	 */
	protected function _init(pEvent:Event):void
	{
		if (!this._animation) {
			this._animation = new Timer(this._animationDelay);
			this._animation.addEventListener(TimerEvent.TIMER, this._animationStep);
			this._animation.start();
		}
		if (!this._motion) {
			this._motion = new Timer(this._motionDelay);
			this._motion.addEventListener(TimerEvent.TIMER, this._motionStep);
			this._motion.start();
		}
	}
	/**
	 * Remove event
	 * 
	 * @param pEvent The event
	 */
	protected function _removed(pEvent:Event):void
	{
		if (this._animation) {
			this._animation.removeEventListener(TimerEvent.TIMER, this._animationStep);
			this._animation.stop();
		}
		if (this._motion) {
			this._motion.removeEventListener(TimerEvent.TIMER, this._motionStep);
			this._motion.stop();
		}
	}
	/**
	 * Animation step event
	 * 
	 * @param pEvent The event
	 */
	protected function _animationStep(pEvent:TimerEvent):void
	{
		
	}
	/**
	 * Motion step event
	 * 
	 * @param pEvent The event
	 */
	protected function _motionStep(pEvent:TimerEvent):void
	{
		
	}
	/*========================= END = PRIVATE = END ==========================*/
	/*========================================================================*/
}

}