package states
{

import flash.display.Bitmap;
import flash.events.TimerEvent;
import mx.core.BitmapAsset;

import states.AState;

/**
 * State drag
 * 
 * @author neolao <neo@neolao.com>
 */
public class Drag extends AState
{
	// ----------------------------- CONSTANTS ---------------------------------
	
	// ----------------------------- VARIABLES ---------------------------------
	static public var stateName:String = "Drag";
	
	[Embed(source="../../images/sheep_run.png")]
	private var _image:Class;
	[Embed(source="../../images/sheep_run2.png")]
	private var _image2:Class;
	
	/*============================= CONSTRUCTOR ==============================*/
	/*========================================================================*/
    /**
     * Constructor
     * 
     * @param pSheepInstance The Sheep instance
     */
    public function Drag(pSheepInstance:Sheep)
    {
        super(pSheepInstance);
    }
    /*======================= END = CONSTRUCTOR = END ========================*/
	/*========================================================================*/

	/*================================ PUBLIC ================================*/
	/*========================================================================*/
	
	/*========================== END = PUBLIC = END ==========================*/
	/*========================================================================*/
	
	/*=============================== PRIVATE ================================*/
	/*========================================================================*/
	/**
	 * Animation step event
	 * 
	 * @param pEvent The event
	 */
	override protected function _animationStep(pEvent:TimerEvent):void
	{
		super._animationStep(pEvent);
		
		var frame:uint = this._animation.currentCount % 2;
		var image:BitmapAsset;
        var bitmap:Bitmap = new Bitmap();
		
		try {
			this.removeChildAt(0);
		} catch (error:*) {
			
		}
		
		switch (frame) {
			default:
			case 0:
				image = new _image() as BitmapAsset;
				break;
			case 1:
				image = new _image2() as BitmapAsset;
				break;
		}
		bitmap.bitmapData = image.bitmapData;
		this.addChild(bitmap);
	}
	/*========================= END = PRIVATE = END ==========================*/
	/*========================================================================*/
}

}