package states
{

import flash.display.Bitmap;
import flash.events.TimerEvent;
import flash.events.Event;
import mx.core.BitmapAsset;
import mx.effects.easing.Bounce;

import states.*;

/**
 * State fall
 * 
 * @author neolao <neo@neolao.com>
 */
public class Fall extends AState
{
	// ----------------------------- CONSTANTS ---------------------------------
	
	// ----------------------------- VARIABLES ---------------------------------
	static public var stateName:String = "Fall";
	
	[Embed(source="../../images/sheep_run.png")]
	private var _image:Class;
	[Embed(source="../../images/sheep_run2.png")]
	private var _image2:Class;
	
	private var _startY:Number = 0;
	
	/*============================= CONSTRUCTOR ==============================*/
	/*========================================================================*/
    /**
     * Constructor
     * 
     * @param pSheepInstance The Sheep instance
     */
    public function Fall(pSheepInstance:Sheep)
    {
        super(pSheepInstance);
    }
    /*======================= END = CONSTRUCTOR = END ========================*/
	/*========================================================================*/

	/*================================ PUBLIC ================================*/
	/*========================================================================*/
	
	/*========================== END = PUBLIC = END ==========================*/
	/*========================================================================*/
	
	/*=============================== PRIVATE ================================*/
	/*========================================================================*/
	/**
	 * Initialization event
	 * 
	 * @param pEvent The event
	 */
	override protected function _init(pEvent:Event):void
	{
		super._init(pEvent);
		
		this._startY = this.stage.window.y;
	}
	/**
	 * Animation step event
	 * 
	 * @param pEvent The event
	 */
	override protected function _animationStep(pEvent:TimerEvent):void
	{
		super._animationStep(pEvent);
		
		var frame:uint = this._animation.currentCount % 2;
		var image:BitmapAsset;
        var bitmap:Bitmap = new Bitmap();
		
		try {
			this.removeChildAt(0);
		} catch (error:*) {
			
		}
		
		switch (frame) {
			default:
			case 0:
				image = new _image() as BitmapAsset;
				break;
			case 1:
				image = new _image2() as BitmapAsset;
				break;
		}
		bitmap.bitmapData = image.bitmapData;
		this.addChild(bitmap);
	}
	/**
	 * Motion step event
	 * 
	 * @param pEvent The event
	 */
	override protected function _motionStep(pEvent:TimerEvent):void
	{
		var duration:Number = 200;
		duration = Math.round(duration / this._screen.height * (this._screen.height - this._startY));
		var nextY:Number = Bounce.easeOut(
			this._motion.currentCount, 							// time
			this._startY,										// start
			this._screen.height - Sheep.HEIGHT - this._startY,	// end
			duration											// duration
		);
		nextY = Math.ceil(nextY);
		this.stage.window.y = nextY;
		if (this._motion.currentCount == duration) {
			this.sheep.state = Stay.stateName;
		}
	}
	/*========================= END = PRIVATE = END ==========================*/
	/*========================================================================*/
}

}